<?php
if (!defined('ABSPATH')) {
    exit;
}

class IOWD_Log
{

    const ERROR_LOG = "error_logs";
    const LOG       = "optimization_logs";

    /**
     * @param $key
     * @param $msg
     */
    public static function set_error_log($key, $msg)
    {
        self::set_log($key, $msg, IOWD_PREFIX . '_' . self::ERROR_LOG);

    }

    /**
     * @param $key
     * @param $msg
     */
    public static function set_optimization_log($key, $msg)
    {
        self::set_log($key, $msg, IOWD_PREFIX . '_' . self::LOG);

    }

    /**
     * @return array
     */
    public static function get_error_logs()
    {
        return self::get_logs(IOWD_PREFIX . '_' . self::ERROR_LOG);
    }

    /**
     * @return array
     */
    public static function get_optimization_logs()
    {
        return self::get_logs(IOWD_PREFIX . '_' . self::LOG);
    }

    public static function clear_optimization_log()
    {
        self::clear_log(IOWD_PREFIX . '_' . self::LOG);
    }

    public static function clear_error_log()
    {
        self::clear_log(IOWD_PREFIX . '_' . self::ERROR_LOG);
    }

    /**
     * @param $option_name
     */
    private static function clear_log($option_name)
    {
        delete_site_transient($option_name);
    }

    /**
     * @param $option_name
     *
     * @return array
     */
    private static function get_logs($option_name)
    {
        $logs = get_site_transient($option_name);
        if (!is_array($logs)) {
            $logs = array();
        }

        return $logs;
    }

    /**
     * @param $key
     * @param $msg
     * @param $option_name
     */
    private static function set_log($key, $msg, $option_name)
    {
        $logs = self::get_logs($option_name);
        if (!$logs) {
            $logs = array();
        }
        // add log to the beginning of existing logs
        if (!(is_string($msg) || is_numeric($msg))) {
            $msg = json_encode($msg);
        }
        $logs[$key] = array('msg' => $msg, 'date' => date('Y-m-d H:i:s'));;
        $expiration = 31 * 24 * 60 * 60;
        set_site_transient($option_name, $logs, $expiration);
    }
}