<?php
if (!defined('ABSPATH')) {
    exit;
}

class IOWD_Api
{
    private static $api_url = null;
    private static $api_action = null;
    private static $post_data = array();
    private static $post_headers_data = array(
        "Accept" => "application/x.optimizer.v2+json"
    );


    /**
     * @param string $method
     *
     * @return bool|mixed
     */
    public static function api_request($method = "POST")
    {
        try {
            if (defined('TENWEB_INCLUDES_DIR')) {
                include_once(TENWEB_INCLUDES_DIR . '/class-tenweb-services.php');
                if (true === \TenwebServices::manager_ready()) {
                    $data["body"] = self::$post_data + array('domain_id' => \TenwebServices::get_domain_id());
                    $data["headers"] = self::$post_headers_data;
                    $data["method"] = $method;

                    $response = \TenwebServices::do_request(self::$api_url, $data);

                    IOWD_Log::set_optimization_log("IOWD_Api:{" . self::$api_action . "}:REQUEST:body", json_encode($data["body"]));
                    IOWD_Log::set_optimization_log("IOWD_Api:{" . self::$api_action . "}:RESPONSE:status", wp_remote_retrieve_response_code($response));

                    if (!is_wp_error($response) || wp_remote_retrieve_response_code($response) === 200) {
                        if (isset($response["body"])) {
                            IOWD_Log::set_optimization_log("IOWD_Api:{" . self::$api_action . "}:RESPONSE:body", json_encode($response["body"]));

                            return json_decode($response['body'], true);
                        }
                    } else {
                        IOWD_Log::set_error_log("IOWD_Api:{" . self::$api_action . "}:RESPONSE", $response);
                    }
                }
            }
        } catch (\Exception $e) {

        }

    }

    /**
     * @param $data
     */
    public static function set_post_data($data)
    {
        self::$post_data = $data;
    }

    /**
     * @param $data
     */
    public static function set_post_headers_data($data)
    {
        self::$post_headers_data = self::$post_headers_data + $data;
    }


    /**
     * @param $api_action
     */
    public static function set_api_action($api_action)
    {
        self::$api_action = $api_action;
        self::$api_url = IOWD_API_URL . $api_action;
    }


}