<?php
if (!defined('ABSPATH')) {
    exit;
}

class IOWD_Logs
{
    /**
     * logs display function
     */
    public function display()
    {
        $this->check_for_log();
        $logs = IOWD_Log::get_optimization_logs();
        $error_logs = IOWD_Log::get_error_logs();

        if (get_option('iowd_show_logs') == "1") {
            require_once(IOWD_DIR_VIEWS . '/iowd_logs_display.php');
        }
    }

    public static function clear_logs()
    {
        if (isset($_POST["action"]) && $_POST["action"] == "clear_logs") {
            check_admin_referer('nonce_' . IOWD_PREFIX, 'nonce_' . IOWD_PREFIX);
            IOWD_Log::clear_error_log();
            IOWD_Log::clear_optimization_log();
        }
    }


    private function check_for_log()
    {
        if (!empty($_REQUEST['iowd_show_logs'])) {
            if ($_REQUEST['iowd_show_logs'] == "1") {
                add_option('iowd_show_logs', "1");
            } else if ($_REQUEST['iowd_show_logs'] == "-1") {
                delete_option('iowd_show_logs');
            }
        }
    }
}