<?php

/**
 * Plugin Name: 10web Image Optimizer
 * Plugin URI: https://10web.io/services/image-optimizer/
 * Description: Image Optimizer WordPress plugin enables you to resize, compress and optimize PNG, JPG, GIF files while maintaining image quality.
 * Version: 5.0.36
 * Author: 10web
 * Author URI: https://10web.io
 * License: GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */

define('IOWD_DIR', WP_PLUGIN_DIR . "/" . plugin_basename(dirname(__FILE__)));
define('IOWD_URL', plugins_url(plugin_basename(dirname(__FILE__))));
define('IOWD_DIR_INCLUDES', IOWD_DIR . '/includes');
define('IOWD_DIR_CLASSES', IOWD_DIR . '/classes');
define('IOWD_DIR_VIEWS', IOWD_DIR . '/views');
define('IOWD_URL_CSS', IOWD_URL . '/assets/css');
define('IOWD_URL_JS', IOWD_URL . '/assets/js');
define('IOWD_URL_IMG', IOWD_URL . '/assets/img');


define('IOWD_NAME', plugin_basename(dirname(__FILE__)));
define('IOWD_MAIN_FILE', plugin_basename(__FILE__));
define('IOWD_PREFIX', "iowd");
//define( 'IOWD_API_URL', "http://localhost/optimizer/api/" );
define('IOWD_API_URL', "https://optimizer.10web.io/api/");
define('IOWD_MANAGER_PREFIX', "tenweb");



if (version_compare(phpversion(), "5.5", '>')) {
    $uri = $_SERVER['REQUEST_URI'];
    if (version_compare(phpversion(), "5.5", '>') && (strpos($uri, "iowd") || (defined('DOING_AJAX') && DOING_AJAX && isset($_POST["action"]) && $_POST["action"] == "optimize"))) {
        setlocale(LC_ALL, 'en_US.UTF-8');
        require_once('vendor/autoload.php');
    }

    if (class_exists("WP_REST_Controller")) {
        require_once('rest/iowd-rest.php');
        add_action('rest_api_init', function () {
            $rest = new IOWD_Rest();
            $rest->register_routes();
        });
    }

    if (is_admin() || (defined('DOING_CRON') && DOING_CRON)) {
        require_once('iowd_class.php');
        register_activation_hook(__FILE__, array('IOWD', 'activate'));

        if (version_compare(phpversion(), "5.4", '>')) {
            require_once(IOWD_DIR_INCLUDES . '/iowd-media-library.php');
            add_action('plugins_loaded', array('IOWD', 'get_instance'));
            register_deactivation_hook(__FILE__, array('IOWD', 'deactivate'));
        }
    }

} else {
    if(!function_exists('deactivate_plugins')){
        require_once ABSPATH . 'wp-admin/includes/plugin.php';
    }
    add_action('admin_notices', 'iowd_php_version_admin_notice');
    deactivate_plugins(IOWD_MAIN_FILE);
}


function iowd_php_version_admin_notice()
{
    ?>
    <div class="notice notice-error">
        <h3>Image Optimizer WD</h3>
        <p><?php _e('This version of the plugin requires PHP 5.6.0 or higher.', 'iowd'); ?></p>
        <p><?php _e('We recommend you to update PHP or ask your hosting provider to do that.', 'buwd'); ?></p>
    </div>
    <?php
}


function detect_plugin_deactivation($plugin, $network_activation)
{
    require_once(IOWD_DIR_INCLUDES . '/iowd-helper.php');
    require_once(IOWD_DIR_INCLUDES . '/iowd-api.php');

    if ($plugin == 'photo-gallery/photo-gallery.php') {
        $data = IOWD_Helper::collect_settings();
        $data["photo_gallery_active"] = 0;
        $data["site_url"] = site_url();
        IOWD_Helper::send_settings_to_api($data);
    }
}

function detect_plugin_activation($plugin, $network_activation)
{
    require_once(IOWD_DIR_INCLUDES . '/iowd-helper.php');
    require_once(IOWD_DIR_INCLUDES . '/iowd-api.php');
    if ($plugin == 'photo-gallery/photo-gallery.php') {
        $data = IOWD_Helper::collect_settings();
        $data["photo_gallery_active"] = 1;
        $data["site_url"] = site_url();
        IOWD_Helper::send_settings_to_api($data);
    }
}
