<?PHP

/**
 * Class WDSViewposts.
 */
class WDSViewposts {
  private $model;

  public function __construct($model) {
    $this->model = $model;

    // Register and include styles and scripts.
    WDS()->register_iframe_scripts();
    wp_print_styles(WDS()->prefix . '_tables');
    wp_print_scripts(WDS()->prefix . '_admin');
  }

  /**
   * Display.
   */
  public function display() {
    $slide_id = WDW_S_Library::get('slide_id', 0);
    $single = $slide_id ? 1 : 0;
    $search_value = ((isset($_POST['search_value'])) ? esc_html(stripslashes($_POST['search_value'])) : '');
    $category_id = ((isset($_POST['category_id'])) ? esc_html(stripslashes($_POST['category_id'])) : '');
    $asc_or_desc = ((isset($_POST['asc_or_desc'])) ? esc_html(stripslashes($_POST['asc_or_desc'])) : 'ASC');
    $order_by = (isset($_POST['order_by']) ? esc_html(stripslashes($_POST['order_by'])) : 'date');
    $count = (isset($_GET['count']) ? esc_html(stripslashes($_GET['count'])) : 0);
    $order_class = 'manage-column column-title sorted ' . $asc_or_desc;

    $datas = $this->model->get_rows_data();
    $rows_data = $datas[0];
    $page_limit = $datas[2];

    ?>
    <form class="wrap wp-core-ui wds_form wds_form_popup" id="posts_form" method="post" action="#">
      <div class="media-modal-content">
        <div class="media-frame-content">
          <div class="tablenav top">
            <?php echo WDW_S_Library::message_id(25); ?>
            <?php WDW_S_Library::search( __('Title', WDS()->prefix), $search_value, 'posts_form'); ?>
            <div class="alignleft actions">
              <div class="alignleft actions">
              <?php
              wp_dropdown_categories(array('hide_empty' => 0, 'name' => 'category_id', 'orderby' => 'name', 'selected' => $category_id, 'hierarchical' => TRUE, 'show_option_none' => __('View all categories', WDS()->prefix), 'class' => 'wds_category_name'));
              ?>
              </div>
            </div>
            <?php
            WDW_S_Library::html_page_nav($datas[1], $page_limit, 'posts_form');
            ?>
          </div>
          <table class="wp-list-table widefat fixed pages media">
            <thead>
              <td id="cb" class="manage-column column-cb check-column">
                <input id="check_all" type="checkbox" />
              </td>
              <th class="column-primary sortable <?php if ($order_by == 'title') {echo $order_class;} ?>">
                <a onclick="spider_set_input_value('order_by', 'title');
                            spider_set_input_value('asc_or_desc', '<?php echo ((isset($_POST['asc_or_desc']) && isset($_POST['order_by']) && (esc_html(stripslashes($_POST['order_by'])) == 'title') && esc_html(stripslashes($_POST['asc_or_desc'])) == 'asc') ? 'desc' : 'asc'); ?>');
                            spider_form_submit(event, 'posts_form')" href="">
                  <span><?php _e('Title', WDS()->prefix);?></span><span class="sorting-indicator"></span>
                </a>
              </th>
              <th class="col-author sortable <?php if ($order_by == 'author') {echo $order_class;} ?>">
                <a onclick="spider_set_input_value('order_by', 'author');
                            spider_set_input_value('asc_or_desc', '<?php echo ((isset($_POST['asc_or_desc']) && isset($_POST['order_by']) && (esc_html(stripslashes($_POST['order_by'])) == 'author') && esc_html(stripslashes($_POST['asc_or_desc'])) == 'asc') ? 'desc' : 'asc'); ?>');
                            spider_form_submit(event, 'posts_form')" href="">
                  <span><?php _e('Author', WDS()->prefix);?></span><span class="sorting-indicator"></span>
                </a>
              </th>
              <th class="col-type"><?php _e('Type', WDS()->prefix);?></th>
              <th class="col-date sortable <?php if ($order_by == 'date') {echo $order_class;} ?>">
                <a onclick="spider_set_input_value('order_by', 'date');
                            spider_set_input_value('asc_or_desc', '<?php echo ((isset($_POST['asc_or_desc']) && isset($_POST['order_by']) && (esc_html(stripslashes($_POST['order_by'])) == 'date') && esc_html(stripslashes($_POST['asc_or_desc'])) == 'asc') ? 'desc' : 'asc'); ?>');
                            spider_form_submit(event, 'posts_form')" href="">
                  <span><?php _e('Date created', WDS()->prefix);?></span><span class="sorting-indicator"></span>
                </a>
              </th>
              <th class="col-modified sortable <?php if ($order_by == 'modified') {echo $order_class;} ?>">
                <a onclick="spider_set_input_value('order_by', 'modified');
                            spider_set_input_value('asc_or_desc', '<?php echo ((isset($_POST['asc_or_desc']) && isset($_POST['order_by']) && (esc_html(stripslashes($_POST['order_by'])) == 'modified') && esc_html(stripslashes($_POST['asc_or_desc'])) == 'asc') ? 'desc' : 'asc'); ?>');
                            spider_form_submit(event, 'posts_form')" href="">
                  <span><?php _e('Date modified', WDS()->prefix);?></span><span class="sorting-indicator"></span>
                </a>
              </th>
            </thead>
            <tbody id="tbody_arr">
              <?php
              $ids_string = '';
              if ( $rows_data ) {
                foreach ( $rows_data as $row_data ) {
                  $alternate = (!isset($alternate) || $alternate == '') ? 'class="alternate"' : '';
                  ?>
                  <tr id="tr_<?php echo $row_data->id; ?>" <?php echo $alternate; ?>>
                    <th class="check-column"><input id="check_<?php echo $row_data->id; ?>" name="check_<?php echo $row_data->id; ?>" type="checkbox" /></th>
                    <td class="column-primary column-title" data-colname="<?php _e('Title', WDS()->prefix); ?>">
                      <strong class="has-media-icon">
                        <a class="wd-pointer" onclick="jQuery('#check_<?php echo $row_data->id; ?>').attr('checked', 'checked'); wds_add_post('<?php echo $row_data->id; ?>,', <?php echo $single ?>);" id="a_<?php echo $row_data->id; ?>">
                          <span class="media-icon image-icon">
                            <img class="preview-image" title="<?php echo $row_data->title; ?>" src="<?php echo $row_data->thumb_url; ?>" width="60" height="60" />
                          </span>
                          <?php echo $row_data->title; ?>
                        </a>
                      </strong>
                      <button class="toggle-row" type="button">
                        <span class="screen-reader-text"><?php _e('Show more details', WDS()->prefix); ?></span>
                      </button>
                    </td>
                    <td data-colname="<?php _e('Author', WDS()->prefix); ?>"><?php echo $row_data->author; ?></td>
                    <td data-colname="<?php _e('Type', WDS()->prefix); ?>"><?php echo $row_data->type; ?></td>
                    <td data-colname="<?php _e('Date created', WDS()->prefix); ?>"><?php echo $row_data->date; ?></td>
                    <td data-colname="<?php _e('Date modified', WDS()->prefix); ?>"><?php echo $row_data->modified; ?></td>
                    <input type="hidden" name="wds_title_<?php echo $row_data->id; ?>" id="wds_title_<?php echo $row_data->id; ?>" value="<?php echo $row_data->title; ?>" />
                    <input type="hidden" name="wds_image_url_<?php echo $row_data->id; ?>" id="wds_image_url_<?php echo $row_data->id; ?>" value="<?php echo $row_data->image_url; ?>" />
                    <input type="hidden" name="wds_thumb_url_<?php echo $row_data->id; ?>" id="wds_thumb_url_<?php echo $row_data->id; ?>" value="<?php echo $row_data->thumb_url; ?>" />
                    <input type="hidden" name="wds_link_<?php echo $row_data->id; ?>" id="wds_link_<?php echo $row_data->id; ?>" value="<?php echo $row_data->link; ?>" />
                    <input type="hidden" name="wds_content_<?php echo $row_data->id; ?>" id="wds_content_<?php echo $row_data->id; ?>" value="<?php echo esc_html($row_data->content); ?>" />
                  </tr>
                  <?php
                  $ids_string .= $row_data->id . ',';
                }
              }
              else {
                echo WDW_S_Library::no_items('');
              }
              ?>
            </tbody>
          </table>
          <input id="asc_or_desc" name="asc_or_desc" type="hidden" value="<?php echo $asc_or_desc; ?>" />
          <input id="order_by" name="order_by" type="hidden" value="<?php echo $order_by; ?>" />
          <input id="slide_id" name="slide_id" type="hidden" value="<?php echo $slide_id; ?>" />
          <input id="ids_string" name="ids_string" type="hidden" value="<?php echo $ids_string; ?>" />
          <input id="task" name="task" type="hidden" value="" />
        </div>
        <div class="media-frame-toolbar">
          <div class="media-toolbar">
            <div class="media-toolbar-primary search-form">
              <button class="button media-button button-primary button-large media-button-insert" type="button" onclick="wds_add_post(jQuery('#ids_string').val(), <?php echo $count; ?>);"><?php _e('Add to slider', WDS()->prefix); ?></button>
            </div>
          </div>
        </div>
      </div>
    </form>
    <?php

    wp_print_scripts('common'); // Check all.

    die();
  }
}
