function wds_get_embed_info(url, layer) {
  if (typeof layer == "undefined") {
    var layer = true;
  }
  jQuery('#opacity_div').show();
  jQuery('#loading_div').show();
  var url = encodeURI(url);
  if (!url) {
    alert(wds_object.translate.please_enter_url_to_embed);

    return false;
  }
  var filesValid = [];
  var data = {
    'action': 'wds_addEmbed',
    'URL_to_embed': url,
    'async':true
  };
  /* get from the server data for the url. Here we use the server as a proxy, since Cross-Origin Resource Sharing AJAX is forbidden. */
  jQuery.post(ajax_url, data, function(response) {
    if (response == false) {
      alert(wds_object.translate.error_cannot_get_response_from_the_server);
      jQuery('#opacity_div').hide();
      jQuery('#loading_div').hide();

      return false;
    }
    else {
      var index_start = response.indexOf("WD_delimiter_start");
      var index_end = response.indexOf("WD_delimiter_end");
      if (index_start == -1 || index_end == -1) {
        alert(wds_object.translate.error_something_wrong_happened_at_the_server);
        jQuery('#opacity_div').hide();
        jQuery('#loading_div').hide();
        return false;
      }
      /*filter out other echoed characters*/
      /*18 is the length of "wd_delimiter_start"*/
      response = response.substring(index_start+18,index_end);  
      response_JSON = jQuery.parseJSON(response);
      /*if indexed array, it means there is error*/
      if (typeof response_JSON[0] !== 'undefined') {
        alert('Error: ' + jQuery.parseJSON(response)[1]);
        jQuery('#opacity_div').hide();
        jQuery('#loading_div').hide();

        return false;
      }
      else {
        fileData = response_JSON;
        filesValid.push(fileData);

        if (layer) {
          var slideID = jQuery("div[id^='wbs_subtab'].wds_sub_active").attr("id");
          slideID = slideID.substr(10);
          wds_add_layer("video", slideID, '', '', filesValid, '');
        }
        else {
          wds_add_embeded_video(filesValid);
        }
        jQuery('#opacity_div').hide();
        jQuery('#loading_div').hide();

        return true;
      }
    }

    return false;
  });

  return true;
}

function wds_add_embeded_video(fileData, type, prefix) {
  if (typeof type == "undefined") {
    var type = "";
  }
  if (typeof prefix == "undefined") {
    var prefix = "";
  }
  if (type == "layer") {
    var slideID = jQuery("div[id^='wbs_subtab'].wds_sub_active").attr("id");
    slideID = slideID.substr(10);
		jQuery("#" + prefix).attr("src", fileData[0]['thumb_url']);
		jQuery("#" + prefix + "_image_url").val(fileData[0]['thumb_url']);
		jQuery("#" + prefix + "_link").val(fileData[0]['filename']);
		jQuery("#" + prefix + "_alt").val(fileData[0]['filetype']);
		jQuery("#" + prefix + "_image_width").val(300);
		jQuery("#" + prefix + "_image_height").val(200);
		wds_scale("#" + prefix + "_image_scale", prefix);         
	}
	else {
    var slides_count = jQuery(".wbs_subtab div[id^='wbs_subtab']").length;
    if (typeof window.parent.wp.media.frames.file_frame.options.id == "undefined") {
      var slideID = wds_add_slide();
    }
    else {
      var slideID = window.parent.wp.media.frames.file_frame.options.id;
    }
 	  jQuery("#image_url" + slideID).val(fileData[0]['filename']);
	  jQuery("#thumb_url" + slideID).val(fileData[0]['thumb_url']);
	  jQuery("#type" + slideID).val(fileData[0]['filetype']);
	  jQuery("#trlink" + slideID).hide();
	  jQuery("#wds_preview_image" + slideID).css("background-image", 'url("' + fileData[0]['thumb_url'] + '")');
	  jQuery("#wds_tab_image" + slideID).css("background-image", 'url("' + fileData[0]['thumb_url'] + '")');
	}
  jQuery("#wds_video_type" + slideID).val("");
  jQuery("#controls" + slideID).hide();
  jQuery("#autoplay" + slideID).show();
  if (fileData[0]['filetype'] == 'EMBED_OEMBED_YOUTUBE_VIDEO') {
    jQuery("#youtube_rel_video" + slideID).show();
  }
  else {
    jQuery("#youtube_rel_video" + slideID).hide();
  }
  if (fileData[0]['filetype'] == 'EMBED_OEMBED_VIMEO_VIDEO') {
    jQuery("#video_loop" + slideID).show();
  }
  jQuery(".edit_thumb").text(wds_object.translate.edit_filmstrip_thumbnail);
}

function wds_add_video(id, type) {
  spider_set_input_value("wds_video_type" + id, type);
  jQuery(".opacity_add_video").show();
  jQuery("#add_embed_help").hide();
  return false;
}